require "version"
class Diet
	include Comparable
	attr_reader :title  
	attr_reader :percentage
	attr_reader :des_plato
	attr_reader :con_plato
	attr_reader :data
	attr_reader :vct
	#inicializamos la clase con un titulo, un porcentaje, un conjunto de platos, un valor calorico y unos valores de proteinas, grasas...
    def initialize(title,percentage,con_plato,vct,data)
        @title=title
        @percentage=percentage
	@con_plato = Array.new + con_plato
	@des_plato = con_plato[0]
	@vct = vct
	@data = Array.new + data
    end
	#operadores de <,<=,>,>=
	def <=>(other)
		vct<=>other.vct
	end
	#operador de ==: compara cada variables de instancia de la clase
	def ==(other)
		title==other.title
		percentage==other.percentage
		des_plato==other.des_plato
		con_plato==other.con_plato
		data==other.data
		vct==other.vct
	end
	#metodo que devuelve el nombre del primer plato
	def obtain_plate
		con_plato[0][0]
	end
	#metodo que devuelve el titulo de la dieta
	def menu_title
		title
	end
	#metodo que devuelve el porcentaje que supone del dia entero
	def daily_percentage
		percentage
	end
	#metodo que devuelve el nombre de uno de los platos
	def one_plate (num)
		con_plato[num][0]

	end
	#metodo que devuelve el nombre del conjunto de platos
	def group_plates
		s = "#{con_plato[0][0]}"
		$i=1
		while $i < con_plato.length do
			s+= ", "
			s+= "#{con_plato[$i][0]}"
			$i+=1
		end
		s
	end
	#metodo que devuelve el valor calorico
	def valor
		vct
	end
	#metodo que devuelve el porcentaje de proteinas
	def prot
		data[0]
	end
	#metodo que devuelve el porcentaje de grasas
	def gras
		data[1]
	end
	#metodo que devuelve el porcentaje de hodratos de carbono
	def hid_car
		data[2]
	end
	#metodo que imprime formateada la dieta completa
	def to_s
		s="#{title} (#{percentage}%)\n"
		$i=0
		while $i<con_plato.length do
			s+= "- #{con_plato[$i][0]}, #{con_plato[$i][1]}, #{con_plato[$i][2]} gr\n"
			$i+=1
		end
		s+="V.C.T | %  #{vct} kcal | #{data[0]}% - #{data[1]} - #{data[2]}" 
		
	end
		
end
