class NewDiet
	include Comparable
	attr_reader :name, :titulo, :ingesta, :platos, :porcentajes, :vct
	def initialize(name,&block)
		@name=name
		@ingesta = ""
		@platos = []
		@porcentajes = []
		instance_eval(&block)
	end

	def <=>(other)
                @porcentajes[0]<=>other.porcentajes[0]
        end
	def ==(other)
		@ingesta==other.ingesta
		@platos==other.platos
		@porcentajes==other.porcentajes
		@vct==other.vct
	end

	def titulo(title)
		@titulo=title
	end

	def ingesta(options = {})

		@ingesta << "(#{options[:min]} - #{options[:max]})" if options[:min] && options[:max]
	end
	
	def plato(options = {})
		platos_tmp=""
		platos_tmp << "- #{options[:descripcion]}, #{options[:porcion]}, #{options[:gramos]} gramos\n" if options[:descripcion] && options[:porcion] && options[:gramos]
		@platos << platos_tmp
	end 		
	def porcentajes(options = {})
		tmp=""
		tmp << "#{options[:vct]}"
		@porcentajes << tmp
		tmp=""  
		tmp << "#{options[:proteinas]}%  #{options[:grasas]}%  #{options[:hidratos]}%" if options[:vct] && options[:proteinas] && options[:grasas] && options[:hidratos] 
		@porcentajes << tmp
		#@vct=options[:vct] if options[:vct]
	end 
	def to_s
		s="#{@titulo} #{@ingesta}%\n"
		$i=0
		for i in 0..platos.length
               		s+="#{@platos[i]}"
			$i=$i+1
		end
                s+="VCT  #{@porcentajes[0]}  |  #{porcentajes[1]}"
		s
	end
end



