Node = Struct.new(:value,:next,:prev)
class List
include Enumerable
	attr_reader :head,:tail
	#inicializamos la lista doblemente enlazada con un head y un tail
	def initialize()
		@head=Node.new()
		@tail=@head
		
	end
	#metodo each que recorre cada nodo del vector para poder usar funciones de Enumerable
	def each
		aux=@head
		while aux.next!=nil
			yield aux.value
			aux=aux.next
		end
	end
	#metodo que extrae el primer elemento de la lista
	def get_first
                other=@head
			@head=@head.next
                other.value
        end
	#metodo que inserta un elemento al principio de la lista
	def add(other)
		nuevo=Node.new(other,nil,nil)
		if(@head==nil)
			@head=nuevo
			@head.next=nil
			@head.prev=nil
			@tail=@head
		
		else
			nuevo.next=@head
			@head.prev=nuevo
			@head=nuevo 
		
		end
	end
	#metodo que añade varios elementos al principio de la lista
	def add_mult(other)
		for i in 0..other.length-1
			add(other[i])		
		end
	end
	#metodo que inserta un elemento al final de la lista
	def add_end(other)
		nuevo=Node.new(other,nil,nil)
		if(@head==@tail)
			if(@head==nil)
				@tail=nuevo
				@head=@tail
			else
				@tail.next=nuevo
				nuevo.prev=@tail
				@tail=nuevo
				@head.next=@tail
			end
		else
			@tail.next=nuevo
			nuevo.prev=@tail
			@tail=nuevo
		end
	end
	#metodo que extrae el ultimo elemento de la lista
	def get_last
		result=""
		if(@head==@tail)
			if(@head==nil)
				result=nil
			else
				result=@tail.value
				@tail=nil
				@head=nil
			end
		else
			result=@tail.value
			@tail=@tail.prev
			@tail.next=nil
		end
		result
	end
	#metodo que inserta varios elementos al final de la lista
	def add_end_mult(other)
		for i in 0..other.length-1
			add_end(other[i])
		end
	end
end
